import java.util.*;

/**
 * Write a description of class SimpleEncoder here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SimpleEncoder
{
    /**
     * Constructor for objects of class SimpleEncoder
     */
    public SimpleEncoder()
    {
    }

    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public List encode(List text)
    {
        Set charSet = new HashSet(text);
        List result = new ArrayList();

        // append the unique character count to result
        encodeCharCount(charSet.size(), result);
        
        // append the character table to result
        encodeCharTable(charSet, result);
        
        Map charMap = makeCharMap(charSet);
        
        // append the encoded text to result
        encodeText(text, charMap, result);
        
        return result;
    }
    
    private void encodeCharCount(int count, List encoded)
    {
        char charCount = (char)count;
        encoded.add(new Character(charCount));
    }

    private void encodeCharTable(Set charSet, List encoded) {
        for(Iterator it = charSet.iterator(); it.hasNext(); ) {
            encoded.add(it.next());
        }
    }

    private Map makeCharMap(Set charSet)
    {
        Map map = new HashMap();
        int index = 0;
        for(Iterator it = charSet.iterator(); it.hasNext(); ) {
            map.put(it.next(), new Character((char)index));
            index++;
        }
        return map;
    }

    private void encodeText(List text, Map charMap, List encoded) {
        for(Iterator it = text.iterator(); it.hasNext(); ) {
            Character ch = (Character)it.next();
            encoded.add(charMap.get(ch));
        }
    }
}
